Subject: [nfsv4] rdattr_error values

From: Stevan Steve Allen <[email-masked]>
Date: Thu, 15 Apr 2004 13:40:23 -0700

READDIR results contain two status areas which may be returned (operation 
status & rdattr_error attribute).   I did not find any mention in the RFC 
or WG archives of restrictions for returned rdattr_error values.  I was 
also not able to determine if READDIR should act like GETATTR and return 
values and bitmask for server supported attrs when unsupported attrs are 
requested on the READDIR operation. 

Are the following errors supported for the rdattr_error attribute? 

NFSERR_ATTRNOTSUPP 
NFSERR_INVAL 
NFSERR_RESOURCE 
NFSERR_SERVERFAULT 
NFS4ERR_DELAY
NFS4ERR_MOVED

Thanks,
Stevan C. Allen

---

From: Spencer Shepler <[email-masked]>
Date: Mon, 19 Apr 2004 10:29:31 -0500

On Apr 15, 2004, at 3:40 PM, Stevan Steve Allen wrote:

>
> READDIR results contain two status areas which may be returned 
> (operation status & rdattr_error attribute).   I did not find any 
> mention in the RFC or WG archives of restrictions for returned 
> rdattr_error values.  I was also not able to determine if READDIR 
> should act like GETATTR and return values and bitmask for server 
> supported attrs when unsupported attrs are requested on the READDIR 
> operation.  
>

The error return values for fattr4_rdattr_error are the same as for 
GETATTR.
I believe this is generally accepted.

The errors defined for READDIR are for the reading of a directory only.

As the RFC states, if the client does not ask for fattr4_rdattr_error, 
then the
server must return an error for the READDIR operation if one of the
resultant "getattrs" fails for some reason.  Therefore, clients should 
make
sure to include fattr4_rdattr_error in their requests if they are 
requesting
attributes.

Spencer